module Opensips
  module Pi
    module Rest
      class SubscribersApp < Sinatra::Base
        
        post "/" do
          required_params :username, :password do
            Opensips::Pi.add(params[:username], params[:password], params[:domain]).tap do |response|
              halt 400, response.last unless response.first
            end
          end

          200
        end

        delete "/:id" do
          Opensips::Pi.remove(params[:id],params[:domain]).tap do |response|
            halt 400, response.last unless response.first
          end

          200
        end

        put "/:id/password" do
          Opensips::Pi.password(params[:id],params[:password],params[:domain]).tap do |response|
            halt 400, response.last unless response.first
          end

          200
        end

        private
        def required_params *keys
          keys.each do |k|
            halt 400 unless params[k].present?
          end

          yield
        end
      end
    end
  end
end